local filename = "SoIHeardYouLikeMusic.rte/music.wav"
--------------------------------------------------------------------------

--------------------------------------------------------------------------
local function ToBitString(n)
	local BitStr = "";
	while (n > 0) do
		local last = math.mod(n,2)
		if(last == 1) then
			BitStr = "1"..BitStr
		else
			BitStr = "0"..BitStr
		end
		n = (n-last)/2
	end
	while string.len(BitStr)<8 do
		BitStr = "0"..BitStr
	end
	return BitStr
end

function GetBytesValue(byte_number, byte_length, filestring)
	local str = ""
	for i=byte_number,byte_number+byte_length,1 do
		str = ToBitString(string.byte(string.sub(filestring, i, i)))..str;
	end
	local result = tonumber(str,2)
	return result
end

function Create(self)
	self.Pos.Y = self.Pos.Y-100;

	self.MaxOffset = 20;

	local io = require("io");
	local file = io.open(filename, "rb")
	if file then
		self.filestring = file:read("*all")
		file:close()
	end
	
	self.Channels = GetBytesValue(23, 1, self.filestring);
	self.BytesPerSecond = GetBytesValue(29, 3, self.filestring);
	self.BitsPerSample = GetBytesValue(35, 1, self.filestring);

	self.dataLablePos = string.find(self.filestring, "data")
	self.BytesTotalPos = self.dataLablePos + 4;
	self.DataPos = self.BytesTotalPos + 4; 

	self.BytesPerSample = self.BitsPerSample / 8;
	self.BytesTotal = GetBytesValue(self.BytesTotalPos, 3, self.filestring);
	self.BytesPerChannel = self.BytesTotal / self.Channels;
	self.duration = self.BytesTotal / self.BytesPerSecond * 1000;
	
	AudioMan:StopMusic();
   	AudioMan:PlayMusic(filename,0,100);
	self.Age = 1;
	self.StartPos = self.Pos;
	self.MusicTimer = Timer();
	self.MaxSample = tonumber(string.rep("1",self.BitsPerSample/self.Channels),2);
	print(self.MaxSample)
	self.MaxSample = self.MaxSample/2;
	self.Offset=0;
end

function Update(self)
	if self.MusicTimer.ElapsedRealTimeMS < self.duration then
		self.Pos = self.StartPos;
		self.ToDelete = false;
		self.ToSettle = false;
		self.Vel = Vector(0,0);

		local progress = self.MusicTimer.ElapsedRealTimeMS/self.duration;
		local sample = GetBytesValue(self.DataPos+(math.ceil(self.BytesTotal*progress)), 0, self.filestring);
		local Offset = (sample-128)/self.MaxSample ;
		self.Offset = self.Offset + Offset;
		local Particle = CreateMOPixel("EQParticle");
		Particle.Pos.X = self.Pos.X;
		Particle.Pos.Y = self.Pos.Y + self.Offset;
		MovableMan:AddParticle(Particle);
		local Particle = CreateMOPixel("EQParticle");
		Particle.Pos.X = self.Pos.X;
		Particle.Pos.Y = self.Pos.Y - self.Offset;
		MovableMan:AddParticle(Particle);
	else
		self.ToDelete = true;	
	end
end
